import math
import sys

print('''下面给出的是Python条件分支语句的最通常的语法: ''')
print('''if boolean_expression1: 
    suite1
elif boolean_expression2:
    suite2
elif boolean_expressionN: 
    suiteN
else:
    else_suite''')
print('''有些情况下，可以将一条if...else语句缩减为单一的条件表达式，条件表达式的语法是：
expression1 if boolean_expression else expression2''')
print('''示例：
offset = 20
if not sys.platform.startswith("win"):
    offset = 10
示例：offset = 20 if sys.platform.startswith("win") else 10
''')
print('''条件分支可用于提高为用户打印的消息，比如，在报告处理的文件数量时，不再打印“0 file(s)”、“1 file(s)”，而是使用一对条件表达式：
"{0} file{1}".format((count if count != 0 else "no"),("s" if count != 1 else ""))''')
print('''
下面给出的是while循环完整的、通常的语法格式：
while boolean_expression:
    while_suite
else:
    else_suite''')
print('''这一函数在给定的列表中搜索目标。如果找到了目标，就使用break语句终止循环，并返回适当的索引位置。
如果找不到目标，就会循环完毕并正常终止，之后执行else的suite：将索引位置设置为-1,并返回该值。''')
print('''示例：\ndef list_find(lst, target):
    index = 0
    while index < len(lst):
        if lst[index] == target:
            break
        index += 1
    else:
        index = -1
    return index''')
print('''与while循环类似，for... in循环的完整语法也包括else分支：
for expression in iterable:
    for_suite
else:
    else_suite''')
print('''示例：\ndef list_find(lst, target):
    for index, x in enumerate(lst):
        if x == target:
            break
    else:
        index = -1 
    return index''')
print('''异常的捕获是使用try ...except 块实现的，其通常语法如下：
try:
    try_suite
except exception_group1 as variable1:
    except_suite1
......
except exception_groupN as variableN:
    except_suiteN
else:
    else_suite
finally:
    finally_suite''')
print('''其中至少要包含一个except块，但else与finally块都是可选的。在try块的suite 正常执行完毕时，会执行else块的suit—如果发生异常，就不会执行。
如果存在一 个finally块，则最后总会执行。每个except分支的异常组可以是一个单独的异常，也可以是包含在括号中的异常元组。
对每个异常组，as variable部分是可选的。如果使用，该变量就会包含发生的异常，并可以在异常块的suite中进行存取。''')
print('''下面给出的是不正确使用的一个实例：
try：
    x = d[5]
except LookupError: # WRONG ORDER
    print("Lookup error occurred")
except KeyError:
    print("lnvalid key used")''')
print('''如果字典d不包含key为5的数据项，那么我们希望产生最具针对性的异常 KeyError,而不是最通常的异常LookupError,但是这里,KeyError except块代码总是无法执行到。
如果产生KeyError异常，就会与LookupError except块匹配，因为 LookupError是KeyError的一个基类，也就是说，在异常体系中，LookupError要高于 KeyError,
因此，在使用多个except块时，我们必须坚持对其排序，从最具针对性的 （在异常体系中最底层）异常到最通常（异常体系中最顶层）的异常。''')
print('''下面给出list_find()函数的最终版本，使用了异常处理：
def list_find(lst, target):
    try:
        index = lst.index(target)
    except ValueError:
        index = -1
    return index''')
print('''try ... except... finally块的一种常见应用是处理文件错误。比如，noblanks.py程序 从命令行读取一个文件名列表，
对其中每个文件，生成一个同名文件，但是后缀名改为.nb,内容上则去除原有文件中的空白行。下面给出的是该程序的read_data()函数：''')
print('''def read_data(filename):
    lines =[]
    fh = None
    try:
        fh = open(filename, encoding="utf8")
        for line in fh:
            if line.strip()：
                lines.append(line)
    except (IOError, OSError) as err:
        print(err)
        return []
    finally:
        if fh is not None:
            fh.close()
    return lines''')
print('''异常提供了一种改变控制流的有用方法。我们可以使用内置的异常，或创建自己的异常，以便产生我们所需要的异常并对其进行处理。有两种可以产生异常的语法：
raise exception(args)
raise exception(args) from original_exception
raise''')
print('''自定义异常是自定义的数据类型(类)。这里我们展示其基本的语法：
class exceptionName(baseException):pass
基类应该为Exception类或继承自Exception的类。''')
print('''示例：
try:
    for row, record in enumerate(table):
        for column, field in enumerate(record):
            for index, item in enumerate(field):
                if item == target:
                    raise FoundException()
except FoundException:
    print("found at ({0}, {1}, {2})".format(row, column, index))
else:
    print("not found")''')
print('''创建一个全局函数或局部函数的通用语法格式如下：
def functionName(parameters):
    suite''')
print('''下面是一个使用heron公式计算三角形面积的实例：
def heron(a, b, c):
    s = (a + b + c)/2
    return math.sqrt(s * (s - a) * (s - b) * (s - c))''')
print('''下面给出一个小函数，该函数的作用是返回给定的字符串，如果超过了指定的长度，就返回缩减版并附加一个indicator：
def shorten(text, length=25, indicator="..."): 
    if len(text) > length:
        text = text[:length - len(indicator)] + indicator
    return text''')


def shorten(text, length=25, indicator="..."):
    if len(text) > length:
        text = text[:length - len(indicator)] + indicator
    return text


print('''结果：shorten("The Road")=''' + shorten("The Road"))
print('''shorten(length=7, text="The Road")=''' + shorten(length=7, text="The Road"))
print('''shorten("The Road", indicator="&", length=7)=''' + shorten("The Road", indicator="&", length=7))
print('''shorten("The Road", 7, "&")=''' + shorten("The Road", 7, "&"))
print('''对函数及其参数进行合理的命名可以使得其他程序员更容易理解函数的用途和用法——对我们自己而言也是如此，尤其在函数创建了一段时间之后。下面给出了一些值得考虑的经验。
■ 使用命名框架，并保持一致性。常量使用UPPERCASE,对类（包括异常）使用TitleCase,对GUI （图形用户界面）函数与方法使用camel-Case,对其他对象则使用lowercase或lowercase_with_underscores 。
■ 对所有名称，要避免使用缩略，除非是标准化并广泛使用的。
■ 合理地使用变量与参数名：x非常适合用作x坐标参数，i适合于用作循环计数器等。通常情况下，名称应该足够长以具备很好的描述性，
名称应该描述数据的含义，而不是其类型（比如，amount_due,而非money） 除非某种使用对特定类型是通用的，比如，shorten()实例的text参数。
■ 函数名与方法名应该可以表明其行为或返回值（依赖于其关心的重点），但绝不应该是为了表示如何实现的——因为实现方法因人而异。
下面给出一些命名实例：
def find(l, s, i=0）:								# BAD
def linear_search(l, s, i=0): 						# BAD
def first_index_of(sorted_name_list, name, start=0）:  # GOOD''')
print('''通过使用docstring,我们可以为任何函数添加文档信息，docstring可以是简单地添加在def行之后、函数代码开始之前的字符串。
比如，下面给出的是前面展示过的 shorten()函数，但这里给出的是完整版：''')
print('''def shorten(text, length=25, indicator="..."):
    """Returns text or a truncated copy with the indicator added
    text is any string; length is the maximum length of the returned
    string (including any indicator); indicator is the string added at
    the end to indicate that the text has been shortened
    >>> shorten("The Road")
    'The Road'
    >>> shorten("No Country for Old Men", 20)
    'No Country for Ol...'
    >>> shorten("Cities of the Plain", 15, "*")
    'Cities of the *'
    """
    if len(text) > length:
        text = text[:length - len(indicator)] + indicator
    return text''')
print('''我们可以使用序列拆分操作符(*)来提供位置参数。比如，如果需要计算某个三角形的面积，并且各个边的长度存放在一个列表中，
就可以进行类似于如下的调用：heron(sides[0], sides[1], sides[2]),或简单地对列表进行拆分，并使用更简单的调用方式heron(*sides)。''')


def product(*args):
    result = 1
    for arg in args:
        result *= arg
    return result


print('''示例：
def product(*args):
    result = 1
    for arg in args:
        result *= arg
    return result''')
print('''结果：product(1,2,3,4)=''' + str(product(1, 2, 3, 4)))
print('''product(5,3,8)=''' + str(product(5, 3, 8)))
print('''product(11)=''' + str(product(11)))
print(
    '''我们可以将关键字参数跟随在位置参数后面，如下面这个用于计算参数和的函数, 其中每个参数被按给定的幕进行运算，例如：''')
print('''def sum_of_powers(*args, power=1):
    result = 0
    for arg in args:
        result += arg ** power 
    return result''')


def sum_of_powers(*args, power=1):
    result = 0
    for arg in args:
        result += arg ** power
    return result


print('''结果：sum_of_powers(1, 3, 5)=''' + str(sum_of_powers(1, 3, 5)))
print('''sum_of_powers(1, 3, 5, power=2)=''' + str(sum_of_powers(1, 3, 5, power=2)))
print('''将*本身作为参数也是可能的，用于表明在*后不应该再出现位置参数，但关键字参数是允许的。
下面给出的是heron()函数的修改版，其中，该函数接收恰好3个位置参数，还有一个可选的关键字参数。''')


def heron2(a, b, c, *, units="meters"):
    s = (a + b + c) / 2
    area = math.sqrt(s * (s - a) * (s - b) * (s - c))
    return "{0} {1}".format(area, units)


print('''示例：
def heron2(a, b, c, *, units="meters"):
    s = (a + b + c) / 2
    area = math.sqrt(s * (s - a) * (s - b) * (s - c))
    return "{0} {1}".format(area, units)''')
print('''结果：heron2(25, 24, 7)=''' + str(heron2(25, 24, 7)))
print('''heron2(41, 9, 40, units="inches")=''' + str(heron2(41, 9, 40, units="inches")))
print('''我们也可以在参数中使用映射拆分操作符，通过这种方式创建的函数可以接受给定的任意数量的关键字参数。
下面的函数只是打印出给定的参数，该函数可以不带参数调用，也可以是有任意数量的位置参数与关键字参数。''')


def print_args(*args, **kwargs):
    for i, arg in enumerate(args):
        print("positional argument {0} = {1}".format(i, arg))
    for key in kwargs:
        print("keyword argument {0} = {1}".format(key, kwargs[key]))


print('''def print_args(*args, **kwargs):
    for i, arg in enumerate(args):
        print("positional argument {0} = {1}".format(i, arg))
    for key in kwargs:
        print("keyword argument {0} = {1}".format(key, kwargs[key]))''')
print('''结果：print_args(1, 2, c=3, k="dog")''')
print_args(1, 2, c=3, k="dog")
print('''程序接受命令行中输入的可选的语言（“en”或"fr"）和一个数字作为参数，并输出给定的每个数字对应的名称。
因此，如果在命令行中给定“123”作为参数，那么该程序将输出“one two three”''')
print('''Language = "en"
ENGLISH = {0: "zero", 1: "one", 2: "two", 3: "three", 4: "four", 5: "five", 6: "six", 7: "seven", 8: "eight", 9: "nine"}
def print_digits(digits):
    dictionary = ENGLISH if Language == "en" else ""
    for digit in digits:
        print(dictionary[int(digit)], end=" ")
    print()''')
Language = "en"
ENGLISH = {0: "zero", 1: "one", 2: "two", 3: "three", 4: "four", 5: "five", 6: "six", 7: "seven", 8: "eight", 9: "nine"}


def print_digits(digits):
    dictionary = ENGLISH if Language == "en" else ""
    for digit in digits:
        print(dictionary[int(digit)], end=" ")
    print()


print('''结果：''')
print_digits([1, 2, 3])
print('''示例：这里需要注意的是global语句的使用,该语句的作用是告知Python,某个变量的作用范围是全局(文件)范围,
对变量的赋值应该应用于全局变量,而不是创建一个同名的本地变量。''')
print('''def main():
    if len(sys.argv) == 1 or sys.argv[1] in "--help":
        print("usage: {0} [en|fr] number".format(sys.argv[0]))
        sys.exit()
    args = sys.argv[1:]
    if args[0] in {"en","fr"}:
        global Language
        Language = args.pop(0)
    print_digits(args.pop(0))''')
print('''Lambda函数是使用如下语法格式创建的：
lambda parameters: expression''')
print('''parameters是可选的，如果提供，通常是逗号分隔的变量名形式，也就是位置参数，当然，def语句支持的完整参数语法格式也可以使用。
expression不能包含分支或循环(但允许使用条件表达式)，也不能包含return (或yield)语句，lambda表达式的结果是一个匿名函数。
调用lambda函数时，返回的结果是对表达式计算产生的结果。 如果expression是一个元组，就应该使用圆括号将其包含起来。''')
print('''下面给出一个简单的lambda函数，其作用是根据参数是否为1决定是否添加s：
s = lambda x:"" if x == 1 else "s"''')
print('''示例：area = lambda b, h: 0.5 * b * h''')
area = lambda b, h: 0.5 * b * h
print('''结果：area(5,6)=''' + str(area(5, 6)))
print('''示例：elements = [(2, 12, "Mg"), (1, 11, "Na"), (1, 3, "Li"), (2, 4, "Be")]
elements.sort(key=lambda e: (e[1], e[2]))''')
elements = [(2, 12, "Mg"), (1, 11, "Na"), (1, 3, "Li"), (2, 4, "Be")]
elements.sort(key=lambda e: (e[1], e[2]))
print("结果：")
print(elements)
print('''前提与后果可以使用assert语句指定，其语法格式如下：
assert boolean_expression, optional_expression''')
print('''如果boolean_expression评价为False,就产生一个AssertionError异常。如果给定了可选的optional_expression,
就将其用作AssertionError异常的参数-对提供错误消息而言，这种做法是有用的。要注意的是，断言是为开发者设计的，而不是面向终端用户的。
通常程序使用中发生的问题(如丢失文件或无效的命令行参数)应该釆用其他途径处理，比如提供错误或日志消息。''')
print('''def product(*args): # pessimistic
    assert all(args), "0 argument"
    result = 1
    for arg in args:
        result *= arg
    return result
def product2(*args): # optimistic
    result = 1
    for arg in args:
        result *= arg
    assert result, "0 argument"
    return result''')
def product(*args): # pessimistic
    assert all(args), "0 argument"
    result = 1
    for arg in args:
        result *= arg
    return result

def product2(*args): # optimistic
    result = 1
    for arg in args:
        result *= arg
    assert result, "0 argument"
    return result
#product(0)
#product2(0)
